import { select, zoom, event } from 'd3';
import { loadAndProcessData } from './loadAndProcessData';
import { cellColorArea } from './cellColorArea';
import { cellShape } from './cellShape';

// Define Variables
const svg = select('svg');
const height = +svg.attr('height');
const width = +svg.attr('width');
const margin = { top: 60, right: 60, bottom: 60, left: 60 };
const cellDiagram = svg.append('g');
let inputData;

// Zoom-in Function
  svg.call(zoom().on('zoom', () => {
    cellDiagram.attr('transform', event.transform);  // .on('zoom' function()) needs to accept a child element of the element it is called on
  }));

// Event Handler
  // let selectedLocation;
  // const onClick = id => {
  //   selectedLocation = id;
  //   render();
  // }

// Data Processing : load and process data & set a state & invoke rendering
loadAndProcessData().then(locationData => {
  inputData = locationData;
  render();
});

// render color area & cell diagram
const render = () => {
  cellDiagram.call(cellShape, {
    height: height,
    width: width,
    margin: margin
  });
  
	cellDiagram.call(cellColorArea, {
    height: height,
    width: width,
    margin: margin,
    inputData
//    ,onClick,
//    selectedLocation
  });

};